import requests
from time import sleep
import os
import traceback

RESTART_COMMAND = "shutdown -r now"
DELAY_COMMAND = 5
DELAY_RESTART = 10
MAX_FAILURES = 10

if __name__ == "__main__":
    fails = 0
    with open("/proc/cpuinfo") as fh:
        machine_id = fh.read().split('\n')[-3].split(':')[1][1:]
    print("Machine id:", machine_id)

    while True:

        try:

            print('Running commander script')
            while(True):
                sleep(DELAY_COMMAND)
                url = f'https://dvic.devinci.fr/api/v3/demo_command/{machine_id}'
                r = requests.get(url)
                fails = 0
                if r.status_code != 200:
                    continue

                j = r.json()
                if "command" in j:
                    print("Exec: ", j['command'])
                    os.system(j['command'])
        except:
            fails += 1
            if fails > MAX_FAILURES:
                os.system(RESTART_COMMAND)
                exit(1)
            traceback.print_exc()
            print("Delaying before restarting")
            sleep(DELAY_RESTART)
